/*
 * string.h
 *
 * Copyright (C) 2017 Aleksandar Andrejevic <theflash@sdf.lonestar.org>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _STRING_H_
#define _STRING_H_

#include <stddef.h>
#include <stdint.h>
#include <limits.h>
#include <ctype.h>

char *strcpy(char *destination, const char *source);
char *strncpy(char *destination, const char *source, size_t n);
int strcmp(const char *str1, const char *str2);
int stricmp(const char *str1, const char *str2);
int strncmp(const char *str1, const char *str2, size_t n);
char *strstr(const char *haystack, const char *needle);
char *strchr(const char *str, char c);
char *strrchr(const char *str, char c);
char *strcat(char *destination, const char *source);
char *strncat(char *destination, const char *source, size_t n);
char *strdup(const char *source);
char *strtok(char *str, const char *delimiters);
char *strtok_r(char *str, const char *delimiters, char **endptr);
size_t strlen(const char *str);
void strrev(char *str);
void memset(void *ptr, int value, size_t n);
void memcpy(void *destination, const void *source, size_t n);
void memmove(void *destination, const void *source, size_t n);
int memcmp(const void *mem1, const void *mem2, size_t n);

#endif
